/*
  Mace - http://MaceHQ.cjb.net
  Copyright 1999
  See the file ReadMe.txt for more information
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Globals.h"
#include "Res.h"
#include "Port.h"
#include "File.h"
#include "Mem.h"
#include "Toolbox.h"
#include "cpu/cpu.h"

void main(void)
{
    U8 * FindP;
    char Type[5], Creator[5], FileName[1024], Temp[256];

    Port_Start();
    CPU_Init();
    Mem_Init();

    /* SET FILENAME OF MAC APPLICATION TO RUN

      Put the Mac app's resource fork file name
      into FileName. ARDI's Executor preceeds the
      resource fork filename with a %
    */
    strcpy(FileName,"%landslid");

    FindP=File_Open(FileName,FILE_FINDER);

    if(!FindP)
        App_Exit();

    File_Info(FindP, Type, Creator);

    sprintf(Temp,"Type '%s', Creator '%s'", Type, Creator);
    Port_Puts(PUTS_DEBUG,"main (main.c)",Temp);

    File_Close(FindP);

    ResP=File_Open(FileName,FILE_RES);

    if(!ResP)
        App_Exit();

    Mem_LoadApp();

    Toolbox_Init(); //This needs to be AFTER Mem_LoadApp()

    CPU_Start();

    File_Close(ResP);

    App_Exit();

    return;
}

void App_Exit(void)
{
    setdis();
    Port_End();
    exit(0);
}

//Flip a Word (U16)
U16 FlipW(U16 a)
{
    return ((U8)(a>>8)+((U8)a<<8));
}

//Flip a Long (U32)
U32 FlipL(U32 a)
{
    return ((a>>24)+((U8)(a >> 16)<<8)+((U8)(a >> 8)<<16)+((U8)a<<24));
}

void HexW (U16 n, char * String)
{
    char Temp[5];

    Port_itoa(n,Temp,16);
    String[0]='\0';

    switch(strlen(Temp)) //Add 0's (make 4A into 004A)
    {
        case 1:
            strcat(String,"0");
        case 2:
            strcat(String,"0");
        case 3:
            strcat(String,"0");
    }

    strcat(String,Temp);

    return;
}

void HexL (U32 n, char * String)
{
    char Temp[9];

    Port_itoa(n,Temp,16);
    String[0]='\0';

    switch(strlen(Temp)) //Add 0's (Make 4A into 0000004A)
    {
        case 1:
            strcat(String,"0");
        case 2:
            strcat(String,"0");
        case 3:
            strcat(String,"0");
        case 4:
            strcat(String,"0");
        case 5:
            strcat(String,"0");
        case 6:
            strcat(String,"0");
        case 7:
            strcat(String,"0");
    }

    strcat(String,Temp);

    return;
}
