/*
  Mace - http://MaceHQ.cjb.net
  Copyright 1999
  See the file ReadMe.txt for more information
*/

//Glue between emulator and CPU core


#ifndef CPU_H
#define CPU_H

#define	D_REGS	8              	/* number of D registers */
#define	A_REGS	9              	/* number of A registers */

#include "Var.h"


extern long D[D_REGS], A[A_REGS];
extern long PC;

int mem_put(long data,int loc,long size);
int mem_req(long loc,long size,long *result);

int setdis(void );


#ifndef _MaceTypes
#define _MaceTypes
typedef unsigned char U8;
typedef unsigned short U16;
typedef unsigned long U32;
#endif

void Mem_CheckStack(void); //Checks for stack and heap collision

U8 Toolbox_ALine(U16 inst); //Returns 1 if it handled the trap

void CPU_Init(void);
void CPU_Start(void);

void Port_Puts(int Type, char * Location, char * Message);

//Types for Port_Puts

//Always display these:
#define PUTS_ERROR   0
#define PUTS_WARNING 1
#define PUTS_INFO    2

//Don't always display these:
#define PUTS_DEBUG   3

#endif //CPU_H